#-------------------------------------------------------------------------------
# Name:        EAN.pyw
# Purpose:     EAN check as website example
#
# Author:      Gerhard Röhner
#
# Created:     25.01.2022
# Copyright:   (c)  2022
# Licence:     Freeware
#-------------------------------------------------------------------------------
import tkinter as tk
import tkinter.ttk as ttk

class app(tk.Frame):

    def __init__(self):
        self.root = tk.Tk()
        super().__init__(self.root)
        self.root.geometry('293x184')
        self.root.title('EAN check')
        self.create_widgets()
        self.mainloop()

    def create_widgets(self):
        self.lEAN13digits = tk.Label()
        self.lEAN13digits.place(x=8, y=16, width=86, height=20)
        self.lEAN13digits['anchor'] = 'w'
        self.lEAN13digits['text'] = 'EAN (13 digits)'
        self.eEAN = tk.Entry()
        self.eEAN.place(x=96, y=16, width=102, height=20)
        self.eEANCV = tk.StringVar()
        self.eEANCV.set('5000112545869')
        self.eEAN['textvariable'] = self.eEANCV
        self.bCheck = tk.Button()
        self.bCheck.place(x=208, y=16, width=75, height=25)
        self.bCheck['command'] = self.bCheck_Command
        self.bCheck['text'] = 'Check'
        self.lTestresult = tk.Label()
        self.lTestresult.place(x=8, y=48, width=70, height=20)
        self.lTestresult['anchor'] = 'w'
        self.lTestresult['text'] = 'Test result'
        self.Output = tk.Text()
        self.Output.place(x=8, y=72, width=272, height=100)
        pass

    def output(self, line):
        self.Output.insert('end', line + '\n')

    def bCheck_Command(self):
        # Input
        EAN = self.eEANCV.get()
        # Processing
        if not EAN.isdigit():
            self.output('An EAN must not contain any characters other than digits!')
        if len(EAN) == 13:
            self.output('Length of EAN: 13 ')
            self.output('Entered check digit: ' + EAN[12])
            sum = 0
            index = 0
            factor = 1
            while index < 12:
                sum = sum + int(EAN[index])*factor
                index = index + 1
                if factor == 1:
                    factor = 3
                else:
                    factor = 1
            if sum % 10 == 0:
                calculatedCheckDigit = 0
            else:
                calculatedCheckDigit = 10 - sum % 10
            if int(EAN[12]) == calculatedCheckDigit:
                self.output('The check digit ' + EAN[12] + ' is correct!')
            else:
                self.output('The entered check digit ' + EAN[12] + ' is incorrect!')
                self.output('The correct check digit is ' + str(calculatedCheckDigit))
        else:
            self.output('The entered EAN has ' + str(len(EAN)) + ' digits!')
            self.output('It must consist of 13 digits.')


app()
